
/****** Object : Table [dbo].[Ping] Copyright TECK SYSTEM SOFT 2024 One ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Ping] = '' WHERE [Ping] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] SET [Availability] = '' WHERE [Availability] IS NULL

INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPing]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Ping]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Ping]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])

FROM

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Ping] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Ping] /*= [Computer] + ':' + [Ping]*/
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability]  

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Ping] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' +  [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Ping] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  as SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPing]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPing] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /* [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPing] PINGS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Ping_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Ping],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[Ping] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND 
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Ping] =  TEMP_JOIN .[Ping] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Ping_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Ping],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Ping_ID) = TEMP_JOIN.[Ping_ID]) AS REQUEST

WHERE
PINGS.[Customer] = REQUEST.[Customer]
AND PINGS.[Site] = REQUEST.[Site]
AND PINGS.[Domain] = REQUEST.[Domain]
AND PINGS.[Computer] = REQUEST.[Computer]
AND PINGS.[Alarm] = REQUEST.[Alarm]
AND PINGS.[Status] = REQUEST.[Status]
AND PINGS.[Availability] = REQUEST.[Availability]
   
TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[PingTemp] 