

/****** Object : Table [dbo].[Printer] Copyright TECK SYSTEM SOFT 2024 One ******/


UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Printer] = '' WHERE [Printer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPrinter]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Printer]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Printer]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])

FROM

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' +  [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Printer] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date] 
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Printer]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Printer] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Printer] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPrinter]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPrinter] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /* [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPrinter] PRINTS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Printer_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Printer],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[Printer] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Printer] =  TEMP_JOIN .[Printer] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Printer_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Printer],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Printer_ID) = TEMP_JOIN.[Printer_ID]) AS REQUEST

WHERE
    PRINTS.[Customer] = REQUEST.[Customer]
AND PRINTS.[Site] = REQUEST.[Site]
AND PRINTS.[Domain] = REQUEST.[Domain]
AND PRINTS.[Computer] = REQUEST.[Computer]
AND PRINTS.[Alarm] = REQUEST.[Alarm]
AND PRINTS.[Availability] = REQUEST.[Availability]
AND PRINTS.[Status] = REQUEST.[Status]

TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[PrinterTemp] 